"""
Django settings for enterprise project.

Generated by 'django-admin startproject' using Django 3.2.

For more information on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""

from pathlib import Path
import os
from datetime import timedelta
from kombu import Exchange, Queue
from decouple import config
from celery.schedules import crontab

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = config('SECRET_KEY')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = []


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'django.contrib.sites',

    #third_party
    'celery',
    'constance',
    'constance.backends.database',
    'corsheaders',
    'django_celery_beat',
    'django_extensions',
    'ordered_model',
    'softdelete',
    'rest_framework',
    'rest_framework_simplejwt.token_blacklist',
    'versatileimagefield',

    #local
    'client_contracts',
    'client_contracts_history',
    'client_event_logs',
    'client_invoices',
    'client_messages',
    'client_package_categories',
    'client_packages',
    'client_priviledged_contract_users',
    'client_sites',
    'client_utils',
    'client_wallet_transactions',
    'clients',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'django.contrib.sites.middleware.CurrentSiteMiddleware',
    "enterprise.middleware.get_request.RequestMiddleware",
]

ROOT_URLCONF = 'enterprise.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [
            os.path.join(BASE_DIR, 'softdelete/templates')
        ],
        #'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
            'loaders': (
                'django.template.loaders.filesystem.Loader',
                'django.template.loaders.app_directories.Loader',
            ),
        },
    },
]

# https://medium.com/better-programming/python-celery-best-practices-ae182730bb81
# http://opensource.newfies-dialer.org/en/latest/celery/celery-configuration.html
# https://www.programmersought.com/article/19865101057/
# Priority queue settings
CELERY_ACKS_LATE = True
CELERYD_PREFETCH_MULTIPLIER = 1

CELERY_QUEUES = (
    Queue("celery", Exchange("celery"), routing_key="celery"),
    Queue("on_request", Exchange("on_request"), routing_key="on_request", queue_arguments={'x-max-priority': 9}),
    Queue("long_request", Exchange("long_request"), routing_key="long_request", queue_arguments={'x-max-priority': 9})
)

WSGI_APPLICATION = 'enterprise.wsgi.application'

'''
maybe add to constance??
'''
EMAIL_HOST = config('PV_EMAIL_HOST')
EMAIL_HOST_USER = config('PV_EMAIL_HOST_USER')
EMAIL_HOST_PASSWORD = config('PV_EMAIL_HOST_PASSWORD')
EMAIL_PORT = config('PV_EMAIL_PORT')
EMAIL_USE_TLS = config('PV_EMAIL_USE_TLS', cast=bool)

# BROKER_URL = "amqp://"
BROKER_URL = 'amqp://guest:guest@localhost:5672//'
CELERY_TIMEZONE = 'Africa/Johannesburg'
# https://www.merixstudio.com/blog/django-celery-beat/
# bypass scheduling
# CELERY_ALWAYS_EAGER = True
CELERY_BEAT_SCHEDULE = {
    # Executes every Friday at 4pm - 'schedule': crontab(hour=16, day_of_week=5),
    'send-client-contract-expiry-reminder': { 
        'task': 'client_utils.tasks.send_client_contract_expiry_reminder', 
        'schedule': crontab(hour='10', minute='10'),
    },          
}

'''
Constance config
pip install django-constance[database]
https://django-constance.readthedocs.io/en/latest/
'''
CONSTANCE_BACKEND = 'constance.backends.database.DatabaseBackend'

CONSTANCE_ADDITIONAL_FIELDS = {
    'image_field': ['django.forms.ImageField', {}]
}

CONSTANCE_CONFIG = {
    'SITE_URL': ('', 'Website url including protocol, e.g. https://example.com/'),
    'SITE_LOGO': ('default.png', 'Company logo', 'image_field'),
    'SITE_NAME': ('', 'Company name - (usually used in emails)'),
    'SITE_DESCRIPTION': ('', 'Website description'),
    'SITE_COVER_IMAGE': ('', 'Cover image on email (optional)'),
    'SITE_TWITTER_LINK': ('', 'Twitter link'),
    'SITE_FACEBOOK_LINK': ('', 'Facebook link'),
    'SITE_INSTAGRAM_LINK': ('', 'Instagram link'),
    'SITE_LINKEDIN_LINK': ('', 'LinkedIn link'),
    'SITE_TS_AND_CS_LINK': ('', 'Website terms and conditions link'),
    'SITE_FAQ_LINK': ('', 'Website frequently asked questions link'),
    'SITE_UNSUBSCRIBE_LINK': ('', 'Website unsubscribe link'),

    'CLIENT_CURRENCY_SYMBOL': ('R', 'Currency symbol'),
    'CLIENT_INVOICE_AUTO_PAYMENT': (True, "Pay invoices automatically using the Client's credit. If False, the Client will have to pay each pending invoice manually", bool),

    'CLIENT_API_EXCLUDED_CHARACTERS': ("[]", "Exclude characters from the Client API, e.g. ['*','8','a','\'']"),
    'CLIENT_API_DIGITS': (True, "Add digits to the Client API", bool),
    'CLIENT_API_ALPHABETS': (True, "Add alphabets to the Client API", bool),
    'CLIENT_API_PUNCTUATION': (False, "Add punctuation to the Client API", bool),
    'CLIENT_API_LENGTH': (32, "Set the length of the Client API code", int),

    'CLIENT_INVOICE_EXCLUDED_CHARACTERS': ("[]", "Exclude characters from the Client API, e.g. ['*','8','a','\"']"),
    'CLIENT_INVOICE_DIGITS': (True, "Add digits to the Client invoice", bool),
    'CLIENT_INVOICE_ALPHABETS': (True, "Add alphabets to the Client invoice", bool),
    'CLIENT_INVOICE_PUNCTUATION': (False, "Add punctuation to the Client invoice", bool),
    'CLIENT_INVOICE_LENGTH': (9, "Set the length of the Client invoice code", int),

    'CLIENT_EMAIL_GREETING': ('Good day', 'Greeting used in the', str),
    'CLIENT_EMAIL_GREETING_INCLUDE_NAME': (True, "Include client name whn sending email notifications", bool),
    'CLIENT_EMAIL_FROM': (EMAIL_HOST_USER, 'Email address used to send mail to clients', str),
    'CLIENT_EMAIL_FROM_NAME': ('No-Reply', 'Name used with email address', str),
    'CLIENT_EMAIL_REPLY_TO': (EMAIL_HOST_USER, 'Email address used to replies from clients', str),
    'CLIENT_EMAIL_REPLY_TO_NAME': ('No-Reply', 'Name used with the reply email address', str),
    'CLIENT_EMAIL_FOOTER': ('Best regards, \n\nThe Team', 'Sign off message sent via email', str),

    'CELERY_HIGH_PRIORITY': (9, 'High priority', int),
    'CELERY_MEDIUM_PRIORITY': (6, 'Medium priority', int),
    'CELERY_LOW_PRIORITY': (3, 'Low priority', int),

    'CLIENT_CREATE': (False, "Create client on admin portal", bool),
    'CLIENT_READ': (False, "Read client on admin portal", bool),
    'CLIENT_UPDATE': (False, "Update client on admin portal", bool),
    'CLIENT_DELETE': (False, "Delete client on admin portal", bool),

    'CLIENT_WALLET_TRANSACTION_CREATE': (False, "Create client wallet transactions on admin portal", bool),
    'CLIENT_WALLET_TRANSACTION_READ': (False, "Read client wallet transactions on admin portal", bool),
    'CLIENT_WALLET_TRANSACTION_UPDATE': (False, "Update wallet transactions client on admin portal", bool),
    'CLIENT_WALLET_TRANSACTION_DELETE': (False, "Delete wallet transactions client on admin portal", bool),

    'CLIENT_INVOICE_CREATE': (False, "Create client invoice on admin portal", bool),
    'CLIENT_INVOICE_READ': (False, "Read client invoice on admin portal", bool),
    'CLIENT_INVOICE_UPDATE': (False, "Update client invoice on admin portal", bool),
    'CLIENT_INVOICE_DELETE': (False, "Delete client invoice on admin portal", bool),

    'CLIENT_CONTRACT_CREATE': (False, "Create client contract on admin portal", bool),
    'CLIENT_CONTRACT_READ': (False, "Read client contract on admin portal", bool),
    'CLIENT_CONTRACT_UPDATE': (False, "Update contract client on admin portal", bool),
    'CLIENT_CONTRACT_DELETE': (False, "Delete contract client on admin portal", bool),
}

CONSTANCE_CONFIG_FIELDSETS = {
    'Client enterprise general options': (
        'SITE_URL',
        'SITE_LOGO',
        'SITE_COVER_IMAGE',
        'SITE_NAME',
        'SITE_DESCRIPTION',
        'SITE_TWITTER_LINK',
        'SITE_FACEBOOK_LINK',
        'SITE_INSTAGRAM_LINK',
        'SITE_LINKEDIN_LINK',
        'SITE_TS_AND_CS_LINK',
        'SITE_FAQ_LINK',
        'SITE_UNSUBSCRIBE_LINK'
    ),
    'Client enterprise payment details': (
        'CLIENT_CURRENCY_SYMBOL',
        'CLIENT_INVOICE_AUTO_PAYMENT'
    ),
    'Client enterprise random string for client API': (
        'CLIENT_API_EXCLUDED_CHARACTERS',
        'CLIENT_API_DIGITS',
        'CLIENT_API_ALPHABETS',
        'CLIENT_API_PUNCTUATION',
        'CLIENT_API_LENGTH',
    ),
    'Client enterprise random string for client INVOICE': (
        'CLIENT_INVOICE_EXCLUDED_CHARACTERS',
        'CLIENT_INVOICE_DIGITS',
        'CLIENT_INVOICE_ALPHABETS',
        'CLIENT_INVOICE_PUNCTUATION',
        'CLIENT_INVOICE_LENGTH'
    ),
    'Clent enterprise email settings' : (
        'CLIENT_EMAIL_GREETING',
        'CLIENT_EMAIL_GREETING_INCLUDE_NAME',
        'CLIENT_EMAIL_FROM',
        'CLIENT_EMAIL_FROM_NAME',
        'CLIENT_EMAIL_REPLY_TO',
        'CLIENT_EMAIL_REPLY_TO_NAME',
        'CLIENT_EMAIL_FOOTER'
    ),

    'Celery priority values': (
        'CELERY_HIGH_PRIORITY',
        'CELERY_MEDIUM_PRIORITY',
        'CELERY_LOW_PRIORITY'
    ),

    'Client enterprise admin settings': (
        'CLIENT_CREATE',
        'CLIENT_READ',
        'CLIENT_UPDATE',
        'CLIENT_DELETE',

        'CLIENT_WALLET_TRANSACTION_CREATE',
        'CLIENT_WALLET_TRANSACTION_READ',
        'CLIENT_WALLET_TRANSACTION_UPDATE',
        'CLIENT_WALLET_TRANSACTION_DELETE',

        'CLIENT_INVOICE_CREATE',
        'CLIENT_INVOICE_READ',
        'CLIENT_INVOICE_UPDATE',
        'CLIENT_INVOICE_DELETE',

        'CLIENT_CONTRACT_CREATE',
        'CLIENT_CONTRACT_READ',
        'CLIENT_CONTRACT_UPDATE',
        'CLIENT_CONTRACT_DELETE',
    ),
}

VERSATILEIMAGEFIELD_RENDITION_KEY_SETS = {
    'product_headshot': [
        ('full_size', 'url'),
        ('thumbnail', 'thumbnail__100x100'),
        ('medium_square_crop', 'crop__400x400'),
        ('small_square_crop', 'crop__50x50')
    ]
}


REST_FRAMEWORK = {
    'DEFAULT_FILTER_BACKENDS': [
        'django_filters.rest_framework.DjangoFilterBackend',
    ],
    'DEFAULT_PERMISSION_CLASSES': (
        'rest_framework.permissions.IsAuthenticated',
    ),
    'DEFAULT_AUTHENTICATION_CLASSES': (
        'rest_framework_simplejwt.authentication.JWTAuthentication',
        'rest_framework.authentication.SessionAuthentication',
    ),
    'DEFAULT_PAGINATION_CLASS': 'client_utils.pagination.ClientCustomPagination',
    'DEFAULT_FILTER_BACKENDS': (
        'rest_framework.filters.SearchFilter',
        'rest_framework.filters.OrderingFilter'
    ),
    'SEARCH_PARAM': 'search',
    'ORDERING_PARAM': 'ordering'
}

SIMPLE_JWT = {
    'ACCESS_TOKEN_LIFETIME': timedelta(days=10),
    'REFRESH_TOKEN_LIFETIME': timedelta(days=15),
    'ROTATE_REFRESH_TOKENS': True,
    'BLACKLIST_AFTER_ROTATION': False,
    'ALGORITHM': 'HS256',
    'SIGNING_KEY': SECRET_KEY,
    'VERIFYING_KEY': None,
    'AUTH_HEADER_TYPES': ('Bearer',),
    'USER_ID_FIELD': 'id',
    'USER_ID_CLAIM': 'user_id',
    'AUTH_TOKEN_CLASSES': ('rest_framework_simplejwt.tokens.AccessToken',),
    'TOKEN_TYPE_CLAIM': 'token_type',
}

CORS_ORIGIN_ALLOW_ALL = False # If this is used then `CORS_ORIGIN_WHITELIST` will not have any effect
CORS_ALLOW_CREDENTIALS = True
CORS_ORIGIN_WHITELIST = [
    'http://localhost:8100',
] # If this is used, then not need to use `CORS_ORIGIN_ALLOW_ALL = True`
CORS_ORIGIN_REGEX_WHITELIST = [
    'http://localhost:8100',
]


# Database
# https://docs.djangoproject.com/en/3.2/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': BASE_DIR / 'db.sqlite3',
    }
}
# DATABASES = {
#     'default': {
#         'ENGINE': 'django.db.backends.postgresql_psycopg2',
#         'NAME': 'database',
#         'USER': 'username',
#         'PASSWORD': 'password',
#         'HOST': '127.0.0.1',
#         'PORT': '5432',
#     }
# }


# Password validation
# https://docs.djangoproject.com/en/3.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


SITE_ID = 1


# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'Africa/Johannesburg'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.2/howto/static-files/

STATIC_URL = '/static/'

STATIC_ROOT = os.path.join(BASE_DIR, "static/")

MEDIA_URL = '/media/'
MEDIA_ROOT = os.path.join(BASE_DIR, 'media')

# Default primary key field type
# https://docs.djangoproject.com/en/3.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'
